class Person:
    def __init__ (self, age, firstname, lastname):
        self._name = firstname + u" " + lastname
        self._age = age

    def set_name (self, firstname, lastname):
        self._name = firstname + " " + lastname

    def get_name (self):
        return self._name

    def presentation (self):
        print("Bonjour je m'appelle " + self._name
            + " et j'ai " + str(self._age) + " ans.")


## Pour tester :
jd = Person(22, "John", "Doe")
jd.presentation()
jd.set_name("Jane", "Doe")
print("Mon nouveau nom est " + jd.get_name() + ".")



class Student (Person):
    def __init__ (self, age, firstname, lastname, year, department):
        Person.__init__(self, age, firstname, lastname)
        self._year = year
        self._dept = department

    def set_year (self, year):
        self._year = year

    def get_year (self):
        return self._year

    def presentation (self):
        Person.presentation(self)
        print("Je suis en " + self._year + " au departement "
              + self._dept + ".")


## Pour tester :
js = Student(22, "Jane", "Doe", "L1", "PIF")
js.set_name("July", "Smith")
js.presentation()



class Group:
    def __init__ (self):
        self._people = []

    def add (self, pers):
        self._people.append(pers)
        print("Added: " + pers.get_name())

    def remove (self, pers):
        if self.is_in(pers):
            self._people.remove(pers)
            print("Removed: " + pers.get_name())

    def is_in (self, pers):
        for p in self._people:
            if p == pers:
                return True
        return False


## Pour tester :
g = Group()
g.add(jd)
g.add(js)
if g.is_in(jd):
    print("ok")
else:
    print("not ok")
g.remove(jd)
if g.is_in(jd):
    print("not ok")
else:
    print("ok")



## EXERCICE :
## Écrire une classe StudentGroup qui a comme attribut le niveau d'étude du
## groupe et qui vérifie à l'ajout que l'étudiant-e ajouté-e est bien du bon
## niveau, sinon affiche une erreur.
